/*
	AcotGrid.cpp

	sIAI
	Vtg{NbNŋ`I
	Rg[{NbNŒǉI


	Copyright(C) 2011, ()GCRbg All rights reserved.

	1.\[XR[h`łoCi`łAύX̗LɊւ炸A
	@ȉ̏𖞂ɂāAĔzzїp܂B

	@1-1.\[XR[h`ōĔzzꍇAL쌠\A {
	@@@ё2̐ӔCKK܂߂ĂB

	@1-2.oCi`ōĔzzꍇAL쌠\A {
	@@@LӔCKAzzƂƂɒ񋟂镶/܂
	@@@̎ɕK܂߂ĂB

	2.{\tgEFA͖ۏ؂łBȐӔCŎgpĂB
 */


#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <stdio.h>
#include <Clipbrd.hpp>

#include "AcotGrid.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck ́A`ꂽR|[lgz֐܂
// ۃNXł͂ȂƂmF邽߂ɒ`Ă܂B
//

static inline void ValidCtrCheck(TAcotGrid *)
{
	new TAcotGrid(NULL);
}



//---------------------------------------------------------------------------
//	class TInplaceEditAg
//---------------------------------------------------------------------------
void __fastcall TInplaceEditAg::SetWordWrap(bool Value)
{
	if (FWordWrap != Value) {
		FWordWrap = Value;
		RecreateWnd();
	}
}
void __fastcall TInplaceEditAg::CreateParams(Controls::TCreateParams &Params)
{
	TInplaceEdit::CreateParams(Params);
	Params.Style = Params.Style | ES_AUTOVSCROLL;
	if (FWordWrap) {
		//Params.Style = Params.Style ^ ES_AUTOHSCROLL; // xor
		Params.Style = Params.Style & ~ES_AUTOHSCROLL; // rbg̃NA
	} else {
		Params.Style = Params.Style | ES_AUTOHSCROLL;
	}
}
void __fastcall TInplaceEditAg::KeyDown(System::Word &Key, Classes::TShiftState Shift)
{
	if (FMultiLine) {
		int istart, istop;
		GetSel(istart, istop);
		TAcotGrid *grid = dynamic_cast<TAcotGrid *>(Grid);
		if (grid == NULL) {
			TInplaceEdit::KeyDown(Key, Shift);
			return;
		}
		if (Key == VK_RETURN) {
			if (Shift.Contains(ssCtrl)) {
				grid->HideEditor();
				Key = 0;
			}
		}
		else if (Key==VK_UP || Key==VK_DOWN || Key==VK_LEFT || Key==VK_RIGHT) {
			if (Shift.Empty()) {
				// 20110502 : J[\擪Ōɂ鎞́Al
				int istart, istop;
				GetSel(istart, istop);
				if (istart == istop) {
					if (istart == 0) {
						if (Key == VK_UP || Key == VK_LEFT) {
							grid->KeyDown(Key, TShiftState());
							Deselect();
							Key = 0;
							return;
						}
					}
					if (istart == GetTextLen()) {
						if (Key == VK_DOWN || Key == VK_RIGHT) {
                        	grid->KeyDown(Key, TShiftState());
							Deselect();
							Key = 0;
							return;
						}
					}
				}
				if (grid->OnKeyDown != NULL)
					grid->OnKeyDown(Grid, Key, Shift);
				return;
			}
			if (Shift.Contains(ssCtrl)) {
				grid->KeyDown(Key, TShiftState());
				Deselect();
				Key = 0;
			}
		}
	} else {
		if (Key == VK_RETURN) {
			Key = VK_RIGHT;
		}
	}
	TInplaceEdit::KeyDown(Key, Shift);
}
void __fastcall TInplaceEditAg::KeyUp(System::Word &Key, Classes::TShiftState Shift)
{
	;
}
void __fastcall TInplaceEditAg::KeyPress(System::WideChar &Key)
{
	if (FMultiLine && (Key == L'\x0d')) {
		TAcotGrid *grid = dynamic_cast<TAcotGrid *>(Grid);
		if (grid != NULL && grid->CanEditModify()) {
			Key = 0x0a;
		}
	}
	TInplaceEdit::KeyPress(Key);
}
//---------------------------------------------------------------------------
//	class TGridColumnAg
//---------------------------------------------------------------------------
__fastcall TGridColumnAg::TGridColumnAg(Classes::TCollection* Collection)
	: TCollectionItem(Collection)
{
	FCanEdit = true;
	FFont = new TFont;
	FFixCellFont = new TFont;
	FFont->Assign(static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Font);
	FFixCellFont->Assign(FFont);
	FColor = static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Color;
	FMultiLine = true;
	ImeMode = imDontCare;
}
__fastcall TGridColumnAg::~TGridColumnAg(void)
{
	delete FFont;
	delete FFixCellFont;
}
void __fastcall TGridColumnAg::SetColor(Graphics::TColor Value)
{
	if (FColor != Value) {
		FColor = Value;
		static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Invalidate();
	}
}
void __fastcall TGridColumnAg::SetFixCellFont(Graphics::TFont* Value)
{
	FFixCellFont->Assign(Value);
	static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Invalidate();
}
void __fastcall TGridColumnAg::SetFont(Graphics::TFont* Value)
{
	FFont->Assign(Value);
	static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Invalidate();
}
void __fastcall TGridColumnAg::SetWordWrap(bool Value)
{
	if (FWordWrap != Value) {
		FWordWrap = Value;
		static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Invalidate();
	}
}
void __fastcall TGridColumnAg::Assign(Classes::TPersistent* Value)
{
	TGridColumnAg *gc = dynamic_cast<TGridColumnAg *>(Value);
	if (gc != NULL) {
		FColumnName = gc->FColumnName;
		FAlignment = gc->FAlignment;
		FDataType = gc->FDataType;
		FDisplayMask = gc->FDisplayMask;
		FCanEdit = gc->FCanEdit;
		FColor = gc->FColor;
		FFont->Assign(gc->FFont);
		FFixCellFont->Assign(gc->FFixCellFont);
		FImeMode = gc->FImeMode;
		FMultiLine = gc->FMultiLine;
		FWordWrap = gc->FWordWrap;
	}
	TCollectionItem::Assign(Value);
}
void __fastcall TGridColumnAg::SetAlignment(Classes::TAlignment Value)
{
	if (FAlignment != Value) {
		FAlignment = Value;
		static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Invalidate();
	}
}
void __fastcall TGridColumnAg::SetColumnName(System::UnicodeString Value)
{
	if (FColumnName != Value) {
		FColumnName = Value;
		static_cast<TGridColumnAgs *>(Collection)->FAcotGrid->Invalidate();
	}
}
//---------------------------------------------------------------------------
//	class TGridColumnAgs
//---------------------------------------------------------------------------
__fastcall TGridColumnAgs::TGridColumnAgs(TAcotGrid* AcotGrid)
	: TCollection(__classid(TGridColumnAg))
{
	FAcotGrid = AcotGrid;
	FCanSizing = true;
}
void __fastcall TGridColumnAgs::SetItems(int Index, TGridColumnAg* Value)
{
	TCollection::SetItem(Index, Value);
}
TGridColumnAg* __fastcall TGridColumnAgs::GetItems(int Index)
{
	return dynamic_cast<TGridColumnAg *>(TCollection::GetItem(Index));
}
void __fastcall TGridColumnAgs::Update(Classes::TCollectionItem* Item)
{
	if (FCanSizing && FAcotGrid->ColCount != Count)
		FAcotGrid->ColCount = Count;
	FAcotGrid->Invalidate();
}
Classes::TPersistent* __fastcall TGridColumnAgs::GetOwner(void)
{
	return FAcotGrid;
}
TGridColumnAg* __fastcall TGridColumnAgs::Add(void)
{
	return dynamic_cast<TGridColumnAg *>(TCollection::Add());
}

//---------------------------------------------------------------------------
//	R}h̋L^ - AhD̎̂
//---------------------------------------------------------------------------

class TDocoCmd
{
private:

public:
	int Col, Row;
	TDocoCmdType Cmd;
	UnicodeString OldStr;
	UnicodeString NewStr;

	TDocoCmd() { }
	TDocoCmd(TDocoCmdType cmd, int col, int row, UnicodeString sold, UnicodeString snew) {
		Set(cmd, col, row, sold, snew);
	}
	~TDocoCmd() { }
	void Set(TDocoCmdType cmd, int col, int row, UnicodeString sold, UnicodeString snew) {
		Cmd = cmd;
		Col = col;
		Row = row;
		OldStr = sold;
		NewStr = snew;
	}
};


//---------------------------------------------------------------------------
//	class TSelRangeList  : public TList
//---------------------------------------------------------------------------
class TSelRangeList  : public TList
{
private:
	TGridRect* __fastcall Get(int idx) {
		return (TGridRect *)TList::Items[idx];
	}
	void __fastcall Put(int idx, TGridRect& value) {
		*((TGridRect *)TList::Items[idx]) = value;
	}
public:
	__fastcall TSelRangeList(void) : TList() { }
	__fastcall virtual ~TSelRangeList(void) { Clear(); }

	void __fastcall SetRect(int idx, TGridCoord& pt1, TGridCoord& pt2) {
		TGridRect *gr = Get(idx);
		if (pt1.X < pt2.X) {
			gr->Left = pt1.X;
			gr->Right = pt2.X;
		}
		else {
			gr->Left = pt2.X;
			gr->Right = pt1.X;
		}
		if (pt1.Y < pt2.Y) {
			gr->Top = pt1.Y;
			gr->Bottom = pt2.Y;
		}
		else {
			gr->Top = pt2.Y;
			gr->Bottom = pt1.Y;
		}
		// [A[́AsȂI
		if (gr->Left == 0)
			gr->Right = 0x7fffffff;
		if (gr->Top == 0)
			gr->Bottom = 0x7fffffff;
	}
	int __fastcall Add(TGridCoord& pt1, TGridCoord& pt2) {
		int idx = TList::Add(new TGridRect);
		SetRect(idx, pt1, pt2);
		return idx;
	}
	int __fastcall Add(TGridRect value) {
		int idx = TList::Add(new TGridRect);
		*Get(idx) = value;
		return idx;
	}
	int __fastcall Add(TGridRect* value) {
		int idx = TList::Add(new TGridRect);
		*Get(idx) = *value;
		return idx;
	}
	virtual void __fastcall Clear(void) {
		for (int i = Count - 1; i >= 0; i--)
			delete (TGridRect *)TList::Items[i];
		TList::Clear();
	}
	void __fastcall Delete(int Index) {
		delete (TGridRect *)TList::Items[Index];
		TList::Delete(Index);
	}
	void __fastcall Clean(void) {
		// 0 ԖڂăNA
		for (int i = Count - 1; i > 0; i--)
			Delete(i);
	}
	int __fastcall Find(int col, int row) {
		for (int i = Count - 1; i >= 0; i--) {
			TGridRect *gr = (TGridRect *)TList::Items[i];
			if (gr->Left <= col && col <= gr->Right
			&&  gr->Top  <= row && row <= gr->Bottom)
				return i;
		}
		return -1;
	}
	bool __fastcall SelSingle() {
		if (Count != 1)
			return false;
		TGridRect *gr = (TGridRect *)TList::Items[0];
		return (gr->Left >= 0) && (gr->Right == gr->Left) && (gr->Bottom == gr->Top);
		//int n = (gr->Right - gr->Left + 1) * (gr->Bottom - gr->Top + 1);
		//return n == 1;
	}
	__property TGridRect Items[int Index] = {read=Get, write=Put};
};


//---------------------------------------------------------------------------
//	class TAcotGrid : public TStringGrid
//---------------------------------------------------------------------------
__fastcall TAcotGrid::TAcotGrid(TComponent* Owner)
	: TStringGrid(Owner)
{
	static struct {
		TCHAR *caption;
		int tag;
		Word shortcut;
		bool ctrl;
		int level;
		TMenuItem *item;
	} menus[] = {
	//	caption,		tag,	shortcut,	ctrl	level	item
		_T("ɖ߂"),	0,		'Z', 		true,	0,		NULL,
		_T("蒼"),	1,		'Y', 		true,	0,		NULL,
		_T("-"),		2,		'\0', 		false,	0,		NULL,
		_T("؂"),	3,		'X', 		true,	0,		NULL,
		_T("Rs["),	4,		'C', 		true,	0,		NULL,
		_T("\t"),	5,		'V', 		true,	0,		NULL,
		_T("NA"),	6,		VK_DELETE,	false,	0,		NULL,
		_T("-"),		-1,		'\0', 		false,	0,		NULL,
		_T("񑀍"),	-1,		'\0', 		false,	0,		NULL,
		  _T("}"),	8,		'\0', 		false,	1,		NULL,
		  _T("ǉ"),	9,		'\0', 		false,	1,		NULL,
		  _T("폜"),	10,		'\0', 		false,	1,		NULL,
		_T("s"),	-1,		'\0', 		false,	0,		NULL,
		  _T("}"),	11,		'\0', 		false,	1,		NULL,
		  _T("ǉ"),	12,		'\0', 		false,	1,		NULL,
		  _T("폜"),	13,		'\0', 		false,	1,		NULL,
	};
	int i;

	FGridColumnAgs  = new TGridColumnAgs(this);

	RepeatPaste = true;
	FlagSelRange = false;
	SelRangeList = new TSelRangeList;
	CurrentPt.X = -1;
	CurrentPt.Y = -1;
	AnchorPt.X = -1;
	AnchorPt.Y = -1;
	SelRangeList->Add(AnchorPt, CurrentPt);

	ColCount = 30;
	RowCount = 30;
	FixedCols = 1;
	FixedRows = 1;
	ColWidths[0] = 32;
	TStringGrid::Cells[0][0] = _T("");
	GridColumnAgs->Items[0]->Alignment = taCenter; // ĴO̓Z^O
	Options >> goEditing >> goAlwaysShowEditor >> goRangeSelect >> goRowSelect;
	Options >> goColMoving >> goRowMoving;
	FlagCellEdit = false;

	// |bvAbvj[̐ݒ
	GridPopup = new TPopupMenu(Owner);
	ColPopup = new TPopupMenu(Owner);
	RowPopup = new TPopupMenu(Owner);
	GridPopup->AutoHotkeys = maManual;
	ColPopup->AutoHotkeys = maManual;
	RowPopup->AutoHotkeys = maManual;
	for (i = 0; i < (int)(sizeof(menus) / sizeof(*menus)); i++) {
		TMenuItem *item = new TMenuItem(GridPopup);
		menus[i].item = item;
		item->Caption = menus[i].caption;
		item->Tag = menus[i].tag;
		item->OnClick = GridPopupClick;
		if (menus[i].shortcut) {
			if (menus[i].ctrl)
				item->ShortCut = ShortCut(menus[i].shortcut, TShiftState() << ssCtrl);
			else
				item->ShortCut = menus[i].shortcut;
		}
		if (menus[i].level > 0) {
			for (int k = i - 1; k >= 0; k--) {
				if (menus[k].level < menus[i].level) {
					menus[k].item->Add(item);
					break;
				}
			}
		} else {
			GridPopup->Items->Add(item);
		}
		if (item->Tag == 8 || item->Tag == 9 || item->Tag == 10) {
			TMenuItem *item2 = new TMenuItem(GridPopup);
			item2->Caption = item->Caption;
			item2->Tag = item->Tag;
			item2->OnClick = item->OnClick;
			ColPopup->Items->Add(item2);
		}
		if (item->Tag == 11 || item->Tag == 12 || item->Tag == 13) {
			TMenuItem *item2 = new TMenuItem(GridPopup);
			item2->Caption = item->Caption;
			item2->Tag = item->Tag;
			item2->OnClick = item->OnClick;
			RowPopup->Items->Add(item2);
		}
	}

	CsvSeparator = _T(',');
	UndoList = new TUndoList;
	UndoIndex = -1;
	UndoCountMark = 0;

	DownX = DownY = -99999;
	MoveX = MoveY = -99999;

	for (i = 1; i < RowCount; i++)
		TStringGrid::Cells[0][i] = i;
	for (i = 1; i < ColCount; i++)
		Cells[i][0] = ColNumber(i);
	OnGetCopyText = NULL;
	OnSetPasteText = NULL;
	DocoCmdList = NULL;
	OnContextPopup = ContextPopup;
}
//---------------------------------------------------------------------------
__fastcall TAcotGrid::~TAcotGrid()
{
	delete FGridColumnAgs;
	delete SelRangeList;
	delete UndoList;
	if (DocoCmdList != NULL) {
		delete DocoCmdList;
		DocoCmdList = NULL;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::ClearUndo()
{
	UndoList->Clear();
	UndoIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::ClearSelRange()
{
	TGridRect gr = Selection;
	CurrentPt = gr.TopLeft;
	AnchorPt = CurrentPt;
	SelRangeList->Clean(); // 0ԖڂăNA
	SelRangeList->SetRect(0, AnchorPt, CurrentPt);
	CellEdit = false;
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TAcotGrid::GetCells(int ACol, int ARow)
{
	// ĴO̍sԍȂ
	//return TStringGrid::Cells[ACol+1][ARow];
	return TStringGrid::Cells[ACol][ARow];
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SetCells(int ACol, int ARow, UnicodeString val)
{
	// ĴO̍sԍȂ
	//TStringGrid::Cells[ACol+1][ARow] = val;
	TStringGrid::Cells[ACol][ARow] = val;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::BeginSubst()
{
	if (DocoCmdList == NULL)
		DocoCmdList = new TDocoCmdList;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::EndSubst()
{
	if (DocoCmdList != NULL) {
		if (DocoCmdList->Count > 0)
			UndoAdd(DocoCmdList);
		else
			delete DocoCmdList;
		DocoCmdList = NULL;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SubstCell(int ACol, int ARow, UnicodeString val)
{
	// J̒luāAҏW
	if (ACol < 0 || ACol >= ColCount || ARow < 0 || ARow >= RowCount)
		return;
	UnicodeString s = GetCells(ACol, ARow);
	if (s != val) {
		SetCells(ACol, ARow, val);
		if (DocoCmdList != NULL)
			DocoCmdList->Add(new TDocoCmd(dcSubst, ACol, ARow, s, val));
	}
}
//---------------------------------------------------------------------------
int __fastcall TAcotGrid::GetRowCount()
{
	return TStringGrid::RowCount;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SetRowCount(int value)
{
	TStringGrid::RowCount = value;
	//for (int i = 0; i < value; i++)
	//	TStringGrid::Cells[0][i] = i;
}
//---------------------------------------------------------------------------
TGridRect __fastcall TAcotGrid::GetSelection(void)
{
	return TStringGrid::Selection;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SetSelection(const TGridRect &Value)
{
	TStringGrid::Selection = Value;
	CurrentPt = Selection.TopLeft;
	AnchorPt = Selection.BottomRight;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SetCsvSeparator(TCHAR sepchar)
{
	CsvSeparator = sepchar;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SetParms(TStringGrid *sgrid)
{
	Parent = sgrid->Parent;
	Align = sgrid->Align;
	Anchors = sgrid->Anchors;
	ColCount = sgrid->ColCount;
	DefaultColWidth = sgrid->DefaultColWidth;
	DefaultRowHeight = sgrid->DefaultRowHeight;
	FixedCols = sgrid->FixedCols;
	FixedRows = sgrid->FixedRows;
	GridLineWidth = sgrid->GridLineWidth;
	Height = sgrid->Height;
	Left = sgrid->Left;
	Options = sgrid->Options;
	//PopupMenu = sgrid->PopupMenu;
	RowCount = sgrid->RowCount;
	ScrollBars = sgrid->ScrollBars;
	TabStop = sgrid->TabStop;
	Tag = sgrid->Tag;
	Top = sgrid->Top;
	Visible = sgrid->Visible;
	Width = sgrid->Width;

	OnClick = sgrid->OnClick;
	OnDblClick = sgrid->OnDblClick;
	OnDragDrop = sgrid->OnDragDrop;
	OnDragOver = sgrid->OnDragOver;
	OnDrawCell = sgrid->OnDrawCell;
	OnEnter = sgrid->OnEnter;
	OnExit = sgrid->OnExit;
	OnGetEditMask = sgrid->OnGetEditMask;
	OnGetEditText = sgrid->OnGetEditText;
	OnKeyDown = sgrid->OnKeyDown;
	OnKeyPress = sgrid->OnKeyPress;
	OnKeyUp = sgrid->OnKeyUp;
	OnMouseDown = sgrid->OnMouseDown;
	OnMouseMove = sgrid->OnMouseMove;
	OnMouseUp = sgrid->OnMouseUp;
	OnSelectCell = sgrid->OnSelectCell;
	OnSetEditText = sgrid->OnSetEditText;
	OnStartDrag = sgrid->OnStartDrag;
	OnTopLeftChanged = sgrid->OnTopLeftChanged;

	DrawingStyle = sgrid->DrawingStyle;
	for (int col = 0; col < ColCount; col++) {
		if (col >= GridColumnAgs->Count)
			break;
		TGridColumnAg *gcol = GridColumnAgs->Items[col];
		gcol->Font->Assign(sgrid->Font);
		gcol->FixCellFont->Assign(sgrid->Font);
		gcol->Color = sgrid->Color;
	}

	Options >> goEditing >> goAlwaysShowEditor >> goRangeSelect >> goRowSelect;
	Options >> goColMoving >> goRowMoving;
	Options << goRowSizing;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::MouseDown(
	Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y)
{
#ifdef MEMORANDUM
	if (͈͑I)
		return
	if (E{^)
		IXgNA
		Jgړ
		AJ[ړ
		|bvAbvj[
		return
	if ({^łȂ)
		return
	Jgړ
	if (VtgȂ)
		AJ[ړ
	if (Rg[Ȃ)
		IXgNA
	AJ[Jg͈̔͂IXgɒǉ
	͈͑IJn
#endif
	DownX = X;
	DownY = Y;

	if (GetGridState(X, Y) != Grids::gsNormal) {
		TStringGrid::MouseDown(Button, Shift, X, Y);
		return;
	}

	if (FlagSelRange)
		return;

	if (Button == mbLeft) {
		CurrentPt = MouseCoord(X, Y);
		ResetSelRange(Shift);
		FlagSelRange = true;
		CellEdit = false;
		Invalidate();
		TStringGrid::MouseDown(Button, Shift, X, Y);

		TGridRect gr;
		gr.TopLeft = CurrentPt;
		gr.BottomRight = CurrentPt;
		if (CurrentPt.X < FixedCols)
			gr.Left = gr.Right = FixedCols;
		if (CurrentPt.Y < FixedRows)
			gr.Top = gr.Bottom = FixedRows;
		Selection = gr;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y)
{
#ifdef MEMORANDUM
	if (͈͑I AND {^)
		͈͑II
#endif

	if (FlagSelRange && Button == mbLeft) {
		FlagSelRange = false;
#if 0
		if (SelRangeList->SelSingle()) {
			Options << goEditing << goAlwaysShowEditor;
			ShowEditor();
		}
#endif
	}

	TStringGrid::MouseUp(Button, Shift, X, Y);
	Selection.TopLeft = CurrentPt;
	Selection.BottomRight = CurrentPt;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::MouseMove(Classes::TShiftState Shift, int X, int Y)
{
#ifdef MEMORANDUM
	if (͈͑I)
		if (Jgς)
			Jgړ
#endif

#if 0
	//TPoint pt = ClientToScreen(TPoint(X, Y));
	//bool moved = !(pt.x == SavePt.x && pt.y == SavePt.y);
	//SavePt = pt;
#endif
	bool moved = X != MoveX || Y != MoveY;
	MoveX = X;
	MoveY = Y;
	if (!moved)
		return;

	if (FlagSelRange) {
		TGridCoord gpt = MouseCoord(X, Y);
		// Z͈̔͂𒴂X,Y͕ɂȂ
		if (gpt.X >= 0 && gpt.Y >= 0
		&& (gpt.X != CurrentPt.X || gpt.Y != CurrentPt.Y)) {
			CurrentPt = gpt;
			SelRangeList->SetRect(0, AnchorPt, CurrentPt);
			Invalidate();
		}
	}
	TStringGrid::MouseMove(Shift, X, Y);
	Selection.TopLeft = CurrentPt;
	Selection.BottomRight = CurrentPt;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::DblClick()
{
	CellEdit = true;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::KeyDown(Word &Key, Classes::TShiftState Shift)
{
	// IPZŁAҏW[hłȂāAL[łȂΕҏWɂ
	if (SelRangeList->SelSingle() && !CellEdit && !IsSelCtrlKey(Key, Shift))
		CellEdit = true;

	if (Options.Contains(goEditing)) {
		TStringGrid::KeyDown(Key, Shift);
		TGridRect gr = Selection;
		if (gr.TopLeft.X != CurrentPt.X || gr.TopLeft.Y != CurrentPt.Y) {
			CurrentPt = gr.TopLeft;
			AnchorPt = CurrentPt;
			SelRangeList->SetRect(0, AnchorPt, CurrentPt);
		}
	}
	else {
		TGridRect gr;
		switch (Key) {
		case VK_LEFT:
		case VK_RIGHT:
		case VK_UP:
		case VK_DOWN:
			TStringGrid::KeyDown(Key, Shift);
			gr = Selection;
			if (gr.TopLeft.X != CurrentPt.X || gr.TopLeft.Y != CurrentPt.Y) {
				CurrentPt = gr.TopLeft;
				ResetSelRange(Shift);
			}
			Invalidate();
			break;
		case VK_BACK: // NA
		case VK_DELETE:
			SelClear();
			break;
		default:
			if (Shift.Contains(ssCtrl)) {
				switch (Key) {
				case 'C': SelCopy(false); break;
				case 'V': SelPaste(); break;
				case 'X': SelCopy(true); break;
				case 'Y': Redo(); break;
				case 'Z': Undo(); break;
				}
			}
			break;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::KeyUp(Word &Key, Classes::TShiftState Shift)
{
	TStringGrid::KeyUp(Key, Shift);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::DrawCell(
	int ACol, int ARow, const TRect &ARect, TGridDrawState AState)
{
	UnicodeString astr;
	TGridColumnAgs *gcols = GridColumnAgs;

	astr = TStringGrid::Cells[ACol][ARow];

	if (ACol < gcols->Count) {

		TGridColumnAg *gcol = gcols->Items[ACol];
		if (AState.Contains(gdFixed)) {
			Canvas->Font = gcol->FixCellFont;
			if (astr.IsEmpty() && ARow == 0)
				astr = gcol->Caption;
		}
		else {
			Canvas->Font = gcol->Font;
			if (SelRangeList->Find(ACol, ARow) >= 0) {
				Canvas->Brush->Color = clHighlight;
				Canvas->Font->Color = clHighlightText;
			}
			else
				Canvas->Brush->Color = Color;
			Canvas->FillRect(ARect);
		}

		int offset;
		if (DefaultRowHeight >= 18)
			offset = 2;
		else
			offset = 1;
		if (AState.Contains(gdFixed))
			offset++;
        RECT r = (RECT)ARect;
		InflateRect(&r, -offset, -offset);
		if ((r.bottom - r.top) < Canvas->TextHeight(_T('A'))) {
			offset = ARect.bottom - ARect.top - Canvas->TextHeight(_T('A'));
			if (offset > 0)
				offset = offset / 2;
			else
				offset = 0;
			r.top = ARect.top + offset;
			r.bottom = ARect.bottom - offset;
		}

		UINT flags;
		if (gcol->WordWrap)
			flags = DT_WORDBREAK | DT_EDITCONTROL;
		else
			flags = DT_EDITCONTROL;
		// [̃J͍sԍŉE
		if (ACol == 0)
			flags |= DT_RIGHT;
		else if (AState.Contains(gdFixed))
			flags |= DT_CENTER;
		else
			switch (gcol->Alignment) {
				case taLeftJustify: flags |= DT_LEFT; break;
				case taRightJustify: flags |= DT_RIGHT; break;
				default: flags |= DT_CENTER;
			}
		r.left += 2;
		DrawTextEx(Canvas->Handle, astr.c_str(), astr.Length(), &r, flags | DT_NOPREFIX, NULL);
	}
}
//---------------------------------------------------------------------------
bool __fastcall TAcotGrid::CanEditModify(void)
{
	if (Col < FGridColumnAgs->Count && !FGridColumnAgs->Items[Col]->CanEdit)
		return false;
	return SelRangeList->SelSingle();
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SizeChanged(int OldColCount, int OldRowCount)
{
	TStringGrid::SizeChanged(OldColCount, OldRowCount);
	FGridColumnAgs->CanSizing = false;
	while (ColCount > FGridColumnAgs->Count) {
		FGridColumnAgs->Add();
	}
	while (ColCount < FGridColumnAgs->Count) {
		FGridColumnAgs->Delete(FGridColumnAgs->Count-1);
	}
	for (int i = OldColCount<1 ? 1 : OldColCount; i < ColCount; i++) {
		Cells[i][0] = ColNumber(i);
	}
	for (int i = OldRowCount<1 ? 1 : OldRowCount; i < RowCount; i++) {
		TStringGrid::Cells[0][i] = i;
	}
	if (OldRowCount != RowCount && Parent != NULL) {
		// [J̕𒲐
		ColWidths[0] =
			Canvas->TextWidth(UnicodeString(RowCount))
			+ Canvas->TextWidth(L"  ")
			+ this->GridLineWidth * 2;
	}
	FGridColumnAgs->CanSizing = true;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::ContextPopup(System::TObject* Sender,
							const Types::TPoint &MousePos, bool &Handled)
{
	PopupCoord = MouseCoord(MousePos.X, MousePos.Y);
	if (PopupCoord.X == 0)
		PopupMenu = PopupCoord.Y > 0 ? RowPopup : NULL;
	else if (PopupCoord.Y == 0)
		PopupMenu = PopupCoord.X > 0 ? ColPopup : NULL;
	else
		PopupMenu = GridPopup;
	/* ɖ߂ */
	GridPopup->Items->Items[0]->Enabled = UndoIndex >= 0;
	/* 蒼 */
	GridPopup->Items->Items[1]->Enabled = (UndoIndex + 1) < UndoList->Count;
	/* \t */
	GridPopup->Items->Items[5]->Enabled = Clipboard()->HasFormat(CF_TEXT);
	/* 񑀍 */
	GridPopup->Items->Items[8]->Enabled = PopupCoord.X > 0;
	/* s */
	GridPopup->Items->Items[9]->Enabled = PopupCoord.Y > 0;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::GridPopupClick(System::TObject *Sender)
{
	//static char *menus[] = {
	//	/*  0 - 2 */ "ɖ߂", "蒼", "-",
	//	/*  3 - 6 */ "؂", "Rs[", "\t", "NA" };
	TMenuItem *item = (TMenuItem *)Sender;
	switch (item->Tag) {
	case  0: Undo(); break;
	case  1: Redo(); break;
	case  3: SelCopy(true); break;
	case  4: SelCopy(false); break;
	case  5: SelPaste(); break;
	case  6: SelClear(); break;
	case  8: InsCol(false); break;
	case  9: InsCol(true); break;
	case 10: DelCol(); break;
	case 11: InsRow(false); break;
	case 12: InsRow(true); break;
	case 13: DelRow(); break;
	}
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TAcotGrid::ColNumber(int n)
{
	UnicodeString rtn;
	int x, y;

	if (n <= 0)
		return rtn;

	do {
		n--;
		x = n / 26;
		y = n % 26;
		rtn = UnicodeString((char)('A' + y)) + rtn;
		n = x;
	} while (x > 0);

	return rtn;
}
//---------------------------------------------------------------------------
bool __fastcall TAcotGrid::IsSelCtrlKey(Word Key, Classes::TShiftState Shift)
{
	// I̐L[𔻒
	static Word tab[] = {
		VK_LEFT, VK_UP, VK_RIGHT, VK_DOWN, VK_BACK, VK_DELETE, VK_CONTROL,
		'C', 'X', 'V', 'Y', 'Z'
	};
	int i;

	for (i = sizeof(tab) / sizeof(*tab) - 1; i >= 0; i--) {
		if (Key == tab[i])
			break;
	}
	if (i < 0)
		return false;
	if (i < 7)
		return true;
	return Shift.Contains(ssCtrl);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SetCellEdit(bool value)
{
	if (value && FlagCellEdit)
		return;

	FlagCellEdit = value;
	if (FlagCellEdit) {
		TGridRect gr;
		gr.TopLeft = CurrentPt;
		gr.BottomRight = CurrentPt;
		Selection = gr;
		SelRangeList->Clean(); // 0ԖڂăNA
		AnchorPt = CurrentPt;
		SelRangeList->SetRect(0, AnchorPt, CurrentPt);
		Options << goEditing << goAlwaysShowEditor;
		ShowEditor();
	}
	else {
		Options >> goEditing >> goAlwaysShowEditor;
		HideEditor();
	}
}
//---------------------------------------------------------------------------
bool __fastcall TAcotGrid::GetCellEdit()
{
	return FlagCellEdit;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::ResetSelRange(Classes::TShiftState Shift)
{
	if (!Shift.Contains(ssShift)) {
		AnchorPt = CurrentPt;
		if (Shift.Contains(ssCtrl))
			SelRangeList->Add(SelRangeList->Items[0]);
		else
			SelRangeList->Clean(); // 0ԖڂăNA
	}
	SelRangeList->SetRect(0, AnchorPt, CurrentPt);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SelCopy(bool fclear)
{
	TMemoryStream *csvFs = new TMemoryStream;
	TStringList *slist = new TStringList;
	TDocoCmdList *cmdlist = new TDocoCmdList;
	UnicodeString buf, svstr;

	for (int row = FixedRows; row < RowCount; row++) {
		slist->Clear();
		for (int col = FixedCols; col < ColCount; col++) {
			if (SelRangeList->Find(col, row) < 0)
				continue;
			if (OnGetCopyText != NULL)
				OnGetCopyText(this, col, row, buf);
			else
				buf = TStringGrid::Cells[col][row];
			slist->Add(buf);
			if (fclear && GridColumnAgs->Items[col]->CanEdit) {
				svstr = TStringGrid::Cells[col][row];
				TStringGrid::Cells[col][row] = _T("");
				cmdlist->Add(new TDocoCmd(dcSubst, col, row, svstr, _T("")));
			}
		}

		if (slist->Count <= 0)
			continue;

		buf = XsvText(slist, CsvSeparator) + _T("\r\n");
		csvFs->Write(buf.c_str(), buf.Length() * buf.ElementSize());
	}
	delete slist;
	if (cmdlist->Count <= 0)
		delete cmdlist;
	else
		UndoAdd(cmdlist);
	TCHAR *p = _T("");
	csvFs->Write(p, sizeof(*p));
	TClipboard *clip = Clipboard();
	clip->SetTextBuf((TCHAR *)csvFs->Memory);
	delete csvFs;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SelPaste()
{
	// Nbv{[hɃeLXgȂ΃^[
	if (!Clipboard()->HasFormat(CF_TEXT))
		return;

	//TDocoCmdList *cmdlist = new TDocoCmdList;
	BeginSubst();
	UnicodeString astr = Clipboard()->AsText;
	UnicodeString svstr, xstr;
	TCHAR sepch, *p, *p_end;
	sepch = JudgeSepChar(astr);
	p = astr.c_str();
	p_end = p + astr.Length();

	if (SelRangeList->SelSingle()) {
		TGridRect *gr = SelRangeList->Items[0];
		int x, y;
		x = gr->Left;
		y = gr->Top;
		while (p < p_end) {
			xstr = _T("");
			int n = GetCsvColumn(p, xstr, sepch);
			if (y >= RowCount) {
				RowCount = y + 1;
				TStringGrid::Objects[0][y] = NULL;
			}
			if (x >= ColCount) {
				ColCount = x + 1;
				// 擪siojObjects  CapInfoList ̃CfbNX
				// Ȃ̂ŁAɂ邽 -1 
				TStringGrid::Objects[x][0] = (TObject *)-1;
			}
			if (OnSetPasteText != NULL) {
				OnSetPasteText(this, x, y, xstr);
			}
			else if (x < ColCount && GridColumnAgs->Items[x]->CanEdit) {
				SubstCell(x, y, xstr);
				//svstr = TStringGrid::Cells[x][y];
				//TStringGrid::Cells[x][y] = xstr;
				//DocoCmdList->Add(new TDocoCmd(dcSubst, x, y, svstr, xstr));
			}
			p += n;
			if (p[0] == _T('\r') && p[1] == _T('\n'))
				p++;
			if (*p == _T('\n')) {
				x = gr->Left;
				y++;
			}
			else
				x++;
			p++;
		}
	}
	else {
		for (int row = FixedRows; p < p_end && row < RowCount; row++) {
			for (int col = FixedCols; p < p_end && col < ColCount; col++) {
				if (SelRangeList->Find(col, row) < 0)
					continue;
				xstr = _T("");
				int n = GetCsvColumn(p, xstr, sepch);

				if (OnSetPasteText != NULL) {
					OnSetPasteText(this, col, row, xstr);
				}
				else if (GridColumnAgs->Items[col]->CanEdit) {
					SubstCell(col, row, xstr);
					//svstr = TStringGrid::Cells[col][row];
					//TStringGrid::Cells[col][row] = xstr;
					//DocoCmdList->Add(new TDocoCmd(dcSubst, col, row, svstr, xstr));
				}

				p += n;
				if (p[0] == _T('\r') && p[1] == _T('\n'))
					p++;
				p++;
				if (p >= p_end && RepeatPaste)
					p = astr.c_str();
			}
		}
	}

	EndSubst();
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SelClear()
{
	TDocoCmdList *cmdlist = new TDocoCmdList;
	UnicodeString svstr;

	for (int row = FixedRows; row < RowCount; row++) {
		for (int col = FixedCols; col < ColCount; col++) {
			if (SelRangeList->Find(col, row) < 0)
				continue;
			if (GridColumnAgs->Items[col]->CanEdit) {
				svstr = TStringGrid::Cells[col][row];
				TStringGrid::Cells[col][row] = _T("");
				cmdlist->Add(new TDocoCmd(dcSubst, col, row, svstr, _T("")));
			}
		}
	}

	if (cmdlist->Count <= 0)
		delete cmdlist;
	else
		UndoAdd(cmdlist);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::InsCol(bool fAppend)
{
	// fAppend==true ̎͌ɒǉ
	int col = fAppend ? PopupCoord.X + 1 : PopupCoord.X;
	InsertCol(col);
	TDocoCmdList *cmdlist = new TDocoCmdList;
	cmdlist->Add(new TDocoCmd(dcInsert, col, -1, _T(""), _T("")));
	UndoAdd(cmdlist);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::InsertCol(int col)
{
	if (col < 1 || col > ColCount)
		return;
	ColCount = ColCount + 1;
	for (int row = 1; row < RowCount; row++) {
		for (int i = ColCount - 2; i >= col; i--) {
			TStringGrid::Cells[i+1][row] = TStringGrid::Cells[i][row];
		}
		TStringGrid::Cells[col][row] = _T("");
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::DelCol()
{
	int delcol = PopupCoord.X;
	TDocoCmdList *cmdlist = new TDocoCmdList;
	UnicodeString svstr;
	for (int row = 1; row < RowCount; row++) {
		svstr = TStringGrid::Cells[delcol][row];
		cmdlist->Add(new TDocoCmd(dcSubst, delcol, row, svstr, _T("")));
	}
	DeleteCol(delcol);
	cmdlist->Add(new TDocoCmd(dcDelete, delcol, -1, _T(""), _T("")));
	UndoAdd(cmdlist);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::DeleteCol(int delcol)
{
	if (delcol < 1 || delcol >= ColCount)
		return;
	for (int row = 1; row < RowCount; row++) {
		for (int col = delcol + 1; col < ColCount; col++) {
			TStringGrid::Cells[col-1][row] = TStringGrid::Cells[col][row];
		}
	}
	ColCount = ColCount - 1;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::InsRow(bool fAppend)
{
	// fAppend==true ̎͌ɒǉ
	int row = fAppend ? PopupCoord.Y + 1 : PopupCoord.Y;
	InsertRow(row);
	TDocoCmdList *cmdlist = new TDocoCmdList;
	cmdlist->Add(new TDocoCmd(dcInsert, -1, row, _T(""), _T("")));
	UndoAdd(cmdlist);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::InsertRow(int row)
{
	if (row < 1 || row > RowCount)
		return;
	RowCount = RowCount + 1;
	for (int col = 1; col < ColCount; col++) {
		for (int i = RowCount - 2; i >= row; i--) {
			TStringGrid::Cells[col][i+1] = TStringGrid::Cells[col][i];
		}
		TStringGrid::Cells[col][row] = _T("");
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::DelRow()
{
	int delrow = PopupCoord.Y;
	TDocoCmdList *cmdlist = new TDocoCmdList;
	UnicodeString svstr;
	for (int col = 1; col < ColCount; col++) {
		svstr = TStringGrid::Cells[col][delrow];
		cmdlist->Add(new TDocoCmd(dcSubst, col, delrow, svstr, _T("")));
	}
	DeleteRow(delrow);
	cmdlist->Add(new TDocoCmd(dcDelete, -1, delrow, _T(""), _T("")));
	UndoAdd(cmdlist);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::DeleteRow(int delrow)
{
	if (delrow < 1 || delrow >= RowCount)
		return;
	for (int col = 1; col < ColCount; col++) {
		for (int row = delrow + 1; row < RowCount; row++) {
			TStringGrid::Cells[col][row-1] = TStringGrid::Cells[col][row];
		}
	}
	RowCount = RowCount - 1;
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TAcotGrid::XsvText(TStrings *list, TCHAR separator)
{
	UnicodeString rtn;
	for (int i = 0; i < list->Count; i++) {
		if (i != 0)
			rtn += separator;
		rtn += EscapeText(list->Strings[i]);
	}
	return rtn;
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TAcotGrid::EscapeText(UnicodeString str)
{
	UnicodeString rtn;
	int xcnt = 0;
	for (int i = 1; i <= str.Length(); i++) {
		TCHAR c = str[i];
		if (c == _T('"'))
			rtn += _T('"');
		if (_tcschr(_T(" ,\"\n\r\t"), c) != NULL)
			xcnt++;
		rtn += c;
	}
	if (xcnt == 0)
		return rtn;
	return UnicodeString(_T('"')) + rtn + _T('"');
}
//---------------------------------------------------------------------------
int __fastcall TAcotGrid::GetCsvColumn(
					TCHAR *str, UnicodeString &rtn, TCHAR sepchar)
		// sepchar : ؂蕶
{
	TCHAR *start = str;
	int quote = 0;
	int spcnt = 0; /* NH[gɈ͂܂ĂȂ󔒂̃JEg */
	TCHAR c;

	// skip space
	if (sepchar != _T(' ')) {
		while (*str == _T(' ') || *str == _T('@'))
			str++;
	}

	for (c = *str; c != _T('\0'); c = *++str) {
		if (quote) {
			spcnt = 0;
			if (c == quote) {
				if (str[1] == quote)
					rtn += *str++;
				else
					quote = 0;
			}
			else
				rtn += c;
		}
		else {
			// VONI[g͊O
			//if (c == '"' || c == '\'')
			if (c == _T('"'))
				quote = c;
			else if (c == sepchar || c == _T('\r') || c == _T('\n'))
				goto func_exit;
			else {
				rtn += c;
				if (c == _T(' ') || c == _T('@'))
					spcnt++;
				else
					spcnt = 0;
			}
		}
	}

func_exit:
	if (spcnt > 0)
		rtn.SetLength( rtn.Length() - spcnt );

	return str - start;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::SetEditText(int ACol, int ARow, const UnicodeString Value)
{
	UnicodeString sv = TStringGrid::Cells[ACol][ARow];
	if (Value == sv)
		return;
	TStringGrid::SetEditText(ACol, ARow, Value);
	UndoAddEditText(ACol, ARow, sv, Value);
	AdjustRowHeight(ARow);
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TAcotGrid::GetEditText(int ACol, int ARow)
{
	TInplaceEditAg *editat = dynamic_cast<TInplaceEditAg *>(InplaceEditor);
	if (editat != NULL) {
		if (ACol < FGridColumnAgs->Count) {
			TGridColumnAg *grcol = FGridColumnAgs->Items[ACol];
			editat->ImeMode = grcol->ImeMode;
			editat->Font->Assign(grcol->Font);
			editat->MultiLine = grcol->MultiLine;
			editat->WordWrap = grcol->WordWrap;
		} else {
			editat->ImeMode = imClose;
			editat->Font->Assign(Font);
		}
		editat->Color = Color;
	}
	return TStringGrid::GetEditText(ACol, ARow);
}
//---------------------------------------------------------------------------
TGridState __fastcall TAcotGrid::GetGridState(int X, int Y)
{
	TGridDrawInfo gdinfo;
	TGridState gstate;
	int idx, spos, sofs;

	CalcDrawInfo(gdinfo);
	CalcSizingState(X, Y, gstate, idx, spos, sofs, gdinfo);
	return gstate;
}

//---------------------------------------------------------------------------
void __fastcall TAcotGrid::Undo()
{
	if (UndoIndex < 0 || UndoIndex >= UndoList->Count)
		return;

	// UndoList->Items[UndoIndex]  Undo
	TDocoCmdList *clist = UndoList->Items[UndoIndex];
	for (int i = clist->Count - 1; i >= 0; i--) {
		TDocoCmd *cmd = clist->Items[i];
		switch (cmd->Cmd) {
		case dcSubst:
			TStringGrid::Cells[cmd->Col][cmd->Row] = cmd->OldStr;
			break;
		case dcInsert:
			if (cmd->Col >= 0)
				DeleteCol(cmd->Col);
			else if (cmd->Row >= 0)
				DeleteRow(cmd->Row);
			break;
		case dcDelete:
			if (cmd->Col >= 0)
				InsertCol(cmd->Col);
			else if (cmd->Row >= 0)
				InsertRow(cmd->Row);
			break;
		}
	}

	UndoIndex--;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::Redo()
{
	int idx = UndoIndex + 1;
	if (idx < 0 || idx >= UndoList->Count)
		return;

	UndoIndex = idx;

	// UndoList->Items[UndoIndex]  Redo
	TDocoCmdList *clist = UndoList->Items[UndoIndex];
	for (int i = 0; i < clist->Count; i++) {
		TDocoCmd *cmd = clist->Items[i];
		switch (cmd->Cmd) {
		case dcSubst:
			TStringGrid::Cells[cmd->Col][cmd->Row] = cmd->NewStr;
			break;
		case dcInsert:
			if (cmd->Col >= 0)
				InsertCol(cmd->Col);
			else if (cmd->Row >= 0)
				InsertRow(cmd->Row);
			break;
		case dcDelete:
			if (cmd->Col >= 0)
				DeleteCol(cmd->Col);
			else if (cmd->Row >= 0)
				DeleteRow(cmd->Row);
			break;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::UndoAddEditText(int col, int row, UnicodeString sold, UnicodeString snew)
{
	TDocoCmd *dcmd = NULL;
	if (UndoIndex >= 0 && UndoIndex < UndoList->Count) {
		TDocoCmdList *cmdlist = UndoList->Items[UndoIndex];
		if (cmdlist->Count == 1) {
			dcmd = cmdlist->Items[0];
			if (dcmd->Cmd != dcSubst || dcmd->Col != col || dcmd->Row != row)
				dcmd = NULL;
		}
	}
	if (dcmd == NULL)
		UndoAdd(dcSubst, col, row, sold, snew);
	else {
		// UndoList ̍Ōオ UndoIndex ƂȂ悤ɂ
		if ((UndoIndex + 1) != UndoList->Count)
			UndoList->Count = UndoIndex + 1;
		dcmd->Set(dcSubst, col, row, dcmd->OldStr, snew); // O͕ςȂ
	}
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::UndoAdd(TDocoCmdType cmd, int col, int row, UnicodeString sold, UnicodeString snew)
{
	TDocoCmdList *cmdlist = new TDocoCmdList;
	cmdlist->Add(new TDocoCmd(cmd, col, row, sold, snew));
	UndoAdd(cmdlist);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::UndoAdd(TDocoCmdList *cmdlist)
{
	// UndoList ̍Ōオ UndoIndex ƂȂ悤ɂ
	if ((UndoIndex + 1) != UndoList->Count)
		UndoList->Count = UndoIndex + 1;

	UndoIndex = UndoList->Add(cmdlist);
}

//---------------------------------------------------------------------------
void __fastcall TAcotGrid::WndProc(Messages::TMessage &Message)
{
	if (FlagSelRange && Message.Msg == WM_TIMER)
		;//TStringGrid::WndProc(Message);
	else
		TStringGrid::WndProc(Message);
}
//---------------------------------------------------------------------------
Grids::TInplaceEdit* __fastcall TAcotGrid::CreateEditor(void)
{
	return new TInplaceEditAg(this);
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::AdjustRowHeight(int ARow)
{
	int lcnt, lmax, col, i;
	UnicodeString s;

	lmax = 0;
	for (col = 0; col < ColCount; col++) {
		s = Cells[col][ARow];
		lcnt = 0;
		for (i = 1; i <= s.Length(); i++) {
			if (s[i] == _T('\x0d'))
				lcnt++;
			else if (s[i] == _T('\x0a')) {
				if (i == 1)
					lcnt++;
				else if (s[i-1] != _T('\x0d'))
					lcnt++;
			}
		}
		if (lcnt > lmax)
			lmax = lcnt;
	}
	if (Parent == NULL) {
		if (Font->Height > 0)
			i = Font->Height;
		else
			i = -Font->Height;
		RowHeights[ARow] = (i + 1) * lmax + DefaultRowHeight;
	} else {
		//RowHeights[ARow] = (Canvas->TextHeight(_T('A'))+1) * lmax + DefaultRowHeight;
		RowHeights[ARow] = (Canvas->TextHeight(_T('A'))+0) * lmax + DefaultRowHeight;
	}
}
//---------------------------------------------------------------------------
int __fastcall TAcotGrid::GetModCount()
{
	return UndoList->Count - UndoCountMark;
}
//---------------------------------------------------------------------------
void __fastcall TAcotGrid::ResetModCount()
{
	UndoCountMark = UndoList->Count;
}
//---------------------------------------------------------------------------
TCHAR __fastcall TAcotGrid::JudgeSepChar(const UnicodeString &str)
{
	// ؂蕶𔻒肷
	UnicodeString xstr;
	TCHAR sepch = _T(',');
	TCHAR *p, *p_end;
	p = str.c_str();
	p_end = p + str.Length();

	int n1 = 0; // J
	int n2 = 0; // '\t' ̕

	while (p < p_end && n1 < 100) {
		xstr.SetLength(0);
		int n = GetCsvColumn(p, xstr, sepch);
		n1++;
		for (int kk = 1; kk <= xstr.Length(); kk++) {
			if (xstr[kk] == _T('\t'))
				n2++;
		}
		p += n;
		if (p[0] == _T('\r') && p[1] == _T('\n'))
			p++;
		p++;
	}
	if (n1 <= n2)
		sepch = _T('\t');

	return sepch;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
namespace Acotgrid
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TAcotGrid)};
		RegisterComponents("Acot", classes, 0);
	}
}
//---------------------------------------------------------------------------
