//---------------------------------------------------------------------------

#ifndef CsvEdUnitH
#define CsvEdUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnCtrls.hpp>
#include <ActnList.hpp>
#include <ActnMan.hpp>
#include <ActnMenus.hpp>
#include <Menus.hpp>
#include <PlatformDefaultStyleActnCtrls.hpp>
#include <ToolWin.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Dialogs.hpp>

#include <StdActns.hpp>
#include <ExtDlgs.hpp>

#include "CsvGrid.h"
#include "ObjList.h"
//---------------------------------------------------------------------------
typedef CObjList<TCsvGrid> TCsvGridList;

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE ŊǗR|[lg
	TCoolBar *CoolBar1;
	TActionManager *ActionManager1;
	TActionMainMenuBar *ActionMainMenuBar1;
	TAction *AboutAct;
	TPageControl *PageControl1;
	TTabSheet *TabSheet1;
	TStringGrid *StringGrid1;
	TAction *SaveAct;
	TAction *CloseAct;
	TFileExit *FileExit1;
	TSaveTextFileDialog *SaveTextFileDialog1;
	TAction *OpenAct;
	TAction *SaveAsAct;
	TOpenTextFileDialog *OpenTextFileDialog1;
	TAction *SearchAct;
	TAction *SearchNextAct;
	TAction *ReplaceAct;
	TFindDialog *FindDialog1;
	TReplaceDialog *ReplaceDialog1;
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall CloseActExecute(TObject *Sender);
	void __fastcall OpenActExecute(TObject *Sender);
	void __fastcall SaveActExecute(TObject *Sender);
	void __fastcall SaveAsActExecute(TObject *Sender);
	void __fastcall AboutActExecute(TObject *Sender);
	void __fastcall SearchActExecute(TObject *Sender);
	void __fastcall SearchNextActExecute(TObject *Sender);
	void __fastcall ReplaceActExecute(TObject *Sender);
	void __fastcall FindDialog1Find(TObject *Sender);
	void __fastcall ReplaceDialog1Find(TObject *Sender);
	void __fastcall ReplaceDialog1Replace(TObject *Sender);
private:	// [U[錾
protected:
	TCsvGrid *CsvGrid;
	TCsvGridList *GridList;

	void __fastcall OpenFile(const UnicodeString &fname, int encidx);

	void __fastcall WMDropFiles(TWMDropFiles &mes);
	BEGIN_MESSAGE_MAP
	 VCL_MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
	END_MESSAGE_MAP(TForm);

public:		// [U[錾
	__fastcall TForm1(TComponent* Owner);
	__fastcall ~TForm1();

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
